package com.halomobi.common;

public interface ConstantPool {
    //logo开关
    String LOGO_SWITCH = "lg_swh";

    String AD_TYPE = "adType";

    String SSP_SDK = "SSP_SDK";

    String A_SDK = "ASDK";

    String UA_KEY = "UA_KEY_web";

    String IMEI = "imei";

    String DEFAULT_IMEI = "000000000000000";

    String DEFAULT_CELLULAR_ID = "0";

    String DEFAULT_LAC = "0";

    enum AdType {
        BANNER("横幅广告", 1), SPLASH("开屏广告", 2), INSERT("插屏广告", 3), NATIVE("原生广告", 4), REWARDVIDEO("激励视频广告", 5), FLOATAD("浮窗广告",6);
        private String name;
        private int type;

        AdType(String name, int type) {
            this.name = name;
            this.type = type;
        }

        static public AdType getAdTypeByType(int type) {
            AdType[] values = AdType.values();
            for (AdType a : values) {
                if (a.getType() == type) {
                    return a;
                }
            }
            return null;
        }

        public String getName() {
            return name;
        }

        public int getType() {
            return type;
        }
    }

    interface EroType {
        //		--------统计的错误------
        int EXCEPTION = -0x0001;
        int LOAD_AD_TIMEOUT = -0x0002;
        int RENDER_AD_TIMEOUT = -0x0003;
        int RENDER_FAILED = -0x0004;
        int AD_SHOW_FAILED = -0x0005;
        int AD_TYPE_NOT_SUPPORT = -0x0006;
        int BACK_EMPTY = -0x0007;
        //--------非公开
        int DOWNLOAD_FAILED = -0x0008;
        int OPEN_APP_FAILED = -0x0009;
        int INSTALL_FAILED = -0x000a;
        int BAD_TRACK = -0x000b;
        int DEEPLINK_FAILED = -0x000c;
        int VIDEO_PLAY_ERROR = -0x000d;
        //		--------不统计的错误------
        int WITHOUT_NET = -0x0500;
        int PARAMS_ERO = -0x0501;
        int ERROR_FILE_NOT_FOUND = -0x0503;
        int ERROR_UNKNOWN_HOST = -0x0504;
        //参数错误
        int PARAM_ERROR = 0X0002;
    }

    interface CloseType {
        int AUTO = 0x00;
        int USER = 0x02;
        int VIEW_DETACH = 0x03;
        int ERROR = 0x04;
        int CLICKED = 0x05;
    }

    interface VideoError {
        int SHOWING = 0x0401; //视频播放过程中不允许加载下一条.
        int PLAYINGERROR = 0x0402; //视频播放过程中报错.
    }


    interface TrackerType {
        int DISPLAY = 0x00;
        int CLICK = 0x01;
        int CLOSE = 0x2;
        int DEEP_LINK = 0x3;
        int S_DOWNLOAD = 0x04;
        int DOWNLOADED = 0x05;
        int INSTALLED = 0x06;
        int INSTALL_START = 0x7;
        int OPEN = 0x08;
        int DEEP_LINK_OPEN = 0x09;
        int MUTE_TRACKER = 0x010;
        int UNMUTE_TRACKER = 0x011;
        int VIDEO_START_TRACKER = 0x012;
        int VIDEO_CLICK_TRACKER = 0x013;
        int VIDEO_PAUSE_TRACKER = 0x014;
        int VIDEO_COMPLETE_TRACKER = 0x015;
        int VIDEO_SKIP_TRACKER = 0x016;
        int VIDEO_PLAYING_0_TRACKER = 0x17;
        int VIDEO_PLAYING_1_TRACKER = 0x18;
        int VIDEO_PLAYING_2_TRACKER = 0x19;
        int VIDEO_PLAYING_3_TRACKER = 0x20;
        int VIDEO_PLAYING_4_TRACKER = 0x21;
        int VIDEO_LOADED_TRACKER = 0x22;

        int DISPLAY_NURL = 0x23;
        int DISPLAY_BURL = 0x24;
    }
}
