package com.halomobi.download;

import com.halomobi.download.bean.DownloadItem;
import com.halomobi.network.net.AbsNetTask;
import com.halomobi.utils.LogUtils;

import java.io.File;
import java.net.HttpURLConnection;

class DownloadTask extends AbsNetTask {

    private DownloadItem downloadItem;

    /**
     * 构造方法
     */
    DownloadTask(DownloadItem item) {
        super(ReqType.Get);
        this.downloadItem = item;
    }

    @Override
    public LaunchMode getLaunchMode() {
        return LaunchMode.ADD_NEW;
    }

    @Override
    public String getName() {
        return getClass().getSimpleName();
    }

    @Override
    protected byte[] getEntity() {
        return new byte[0];
    }

    @Override
    protected String getUrl() throws Exception {
        return downloadItem.getDownLoadUrl();
    }

    @Override
    protected void onAddHeaders(HttpURLConnection connection) {

        if (downloadItem.getCurrentFileSize() != 0) {
            File file = new File(downloadItem.getSavePath());
            if (file.exists()) {
            LogUtils.e("fza" + "path:" + downloadItem.getSavePath() + " length:" + file.length() + "name: " + downloadItem.getName());
                downloadItem.setLocalFileSize(file.length());
            } else {
                downloadItem.setLocalFileSize(0);
            }
        }
        connection.setRequestProperty("Range", "bytes=" + downloadItem.getLocalFileSize() + "-");
    }
}
