package com.halomobi.download.database;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

public class DownloadDBHelper extends SQLiteOpenHelper {

    private static final String DATABASE_NAME = "ssp_download_info.db";
    static final String TABLE_NAME = "download_info";
    static final String FILE_NAME = "name";
    static final String FILE_SIZE = "size";
    static final String FILE_DESC = "description";//文件描述
    static final String FILE_DOWN_URL = "down_url";
    static final String FILE_DOWN_PATH = "down_path";//本地保存路径
    static final String E_TAG = "e_tag";
    static final String FILE_STATE = "file_state";//下载状态
    static final String START_TIME = "start_time";//下载开始时间
    public static final String DOWNLOAD_START_TRACKER = "down_start_tracks";
    public static final String DOWNLOADED_TRACKER = "down_complete_tracks";
    public static final String INSTALL_START_TRACKER = "install_start_tracks";
    public static final String INSTALLED_TRACKER = "install_complete_tracks";
    public static final String OPEN_TRACKER = "open_tracker";
    public static final String CLICK_TRACKER = "click_tracks";
    public static final String DEEP_LINK_TRACKER = "dp_tracks";
    public static final String DEEP_LINK_PATH = "deep_link_path";
    static final String DOWNLOAD_EXPIRATION_TIME = "download_expiration_time";
    static final String NET_TYPE = "net_type";
    private static final String APP_ICON = "app_icon";
    private static final String APP_VERSION = "app_version";
    private static final String RESERVE_1 = "reserve_1";
    private static final String RESERVE_2 = "reserve_2";
    private static final String CREATE_TABLE = "CREATE TABLE IF NOT EXISTS "
            + TABLE_NAME
            + " ( "
            + FILE_NAME
            + " TEXT , "
            + FILE_SIZE
            + " INTEGER , "
            + FILE_DESC
            + " TEXT , "
            + FILE_DOWN_URL
            + " TEXT , "
            + DOWNLOAD_START_TRACKER
            + " TEXT , "
            + DOWNLOADED_TRACKER
            + " TEXT , "
            + INSTALL_START_TRACKER
            + " TEXT , "
            + INSTALLED_TRACKER
            + " TEXT , "
            + APP_ICON
            + " TEXT , "
            + APP_VERSION
            + " TEXT , "
            + RESERVE_1
            + " TEXT , "
            + RESERVE_2
            + " TEXT , "
            + OPEN_TRACKER
            + " TEXT , "
            + CLICK_TRACKER
            + " TEXT , "
            + DEEP_LINK_TRACKER
            + " TEXT , "
            + DEEP_LINK_PATH
            + " TEXT , "
            + FILE_DOWN_PATH
            + " TEXT , "
            + FILE_STATE
            + " INTEGER , "
            + DOWNLOAD_EXPIRATION_TIME
            + " INTEGER , "
            + START_TIME
            + " INTEGER , "
            + NET_TYPE
            + " INTEGER , "
            + E_TAG
            + " TEXT ,PRIMARY KEY(" + FILE_DOWN_URL + "));";
    static final String ADD_SQL = "REPLACE INTO " + TABLE_NAME + "("
            + FILE_NAME + " , " + FILE_SIZE + " , "
            + FILE_DESC + " , " + FILE_DOWN_URL + " , " + DOWNLOAD_START_TRACKER + " , " + DOWNLOADED_TRACKER + " , "
            + INSTALL_START_TRACKER + " , " + INSTALLED_TRACKER + " , " + OPEN_TRACKER + " , " + CLICK_TRACKER + " , "
            + DEEP_LINK_TRACKER + " , " + DEEP_LINK_PATH + " , "
            + FILE_DOWN_PATH + " , " + FILE_STATE + " , " + DOWNLOAD_EXPIRATION_TIME + " , "
            + START_TIME + " , " + NET_TYPE + " , " + E_TAG
            + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
    //---------------------记录安装失败信息----------------------
    static final String INSTALL_FAILED_TABLE_NAME = "install_failed_table_name";
    static final String APP_NAME = "app_name";
    static final String APP_PACKAGE_NAME = "app_package_name";
    static final String COUNT = "count";
    private static final String CREATE_INSTALL_FAILED_TABLE = "CREATE TABLE IF NOT EXISTS "
            + INSTALL_FAILED_TABLE_NAME
            + " ( "
            + APP_NAME
            + " TEXT , "
            + APP_PACKAGE_NAME
            + " TEXT , "
            + COUNT
            + " INTEGER DEFAULT 0 , "
            + "PRIMARY KEY(" + APP_NAME + " , " + APP_PACKAGE_NAME + "));";
    static final String ADD_INSTALL_FAILED_INFO = "REPLACE INTO " + INSTALL_FAILED_TABLE_NAME
            + "(" + APP_NAME + " , " + APP_PACKAGE_NAME + " , "
            + COUNT + " ) VALUES (?,?,1)";
    private static final int DATABASE_VERSION = 3;

    //---------------------记录安装失败信息----------------------

    DownloadDBHelper(Context context) {
        super(context, DATABASE_NAME, null, DATABASE_VERSION);
    }

    @Override
    public void onCreate(SQLiteDatabase db) {
        db.execSQL(CREATE_TABLE);
        db.execSQL(CREATE_INSTALL_FAILED_TABLE);
    }

    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {

        db.execSQL("DROP TABLE IF EXISTS " + TABLE_NAME);
        db.execSQL("DROP TABLE IF EXISTS " + INSTALL_FAILED_TABLE_NAME);
        db.execSQL(CREATE_TABLE);
        db.execSQL(CREATE_INSTALL_FAILED_TABLE);

    }
}
