package com.halomobi.network.listeners;

import com.halomobi.network.request.ad.bean.Ad;

import java.util.List;

/**
 * 广告各种状态的回调
 *
 * @author jeven
 */
public interface AdStateChangListener {

    /**
     * 广告加载前准备
     */
    void onStart();

    /**
     * 广告加载失败
     *
     * @param errorMsg  错误信息
     * @param errorCode 错误码
     */
    void onAdError(String errorMsg, int errorCode);

    /**
     * 广告返回
     *
     * @param adInfo 广告对象
     */
    void onAdReach(Ad adInfo);

    /**
     * 原生类型广告返回
     *
     * @param adInfoList 广告集合对象
     */
    void onNativeAdReach(List<Ad> adInfoList);

}
