package com.halomobi.network.net;


import com.halomobi.download.DownloadProcessor;
import com.halomobi.network.request.ad.RequestAdProcessor;
import com.halomobi.network.schedule.TaskManager;
import com.halomobi.network.schedule.ThreadManager;
import com.halomobi.utils.LogUtils;

public abstract class AbsNetProcessor implements NetTaskListener {

    private TaskManager mTaskManager = null;

    protected abstract AbsNetTask createNetTask();

    public void setNetTaskManager(TaskManager manager) {
        mTaskManager = manager;
    }

    public void process() {
        AbsNetTask netTask = createNetTask();
        LogUtils.d(netTask.getName() + "  start process");
        netTask.setListener(this);
        // 默认是自启动模式.
        if (mTaskManager != null) {
            mTaskManager.addTask(netTask);
            return;
        }

        if (this instanceof DownloadProcessor) {
            LogUtils.d("当前任务是下载任务");
            ThreadManager.getDownloadPool().execute(netTask);
            return;
        }

        if (this instanceof RequestAdProcessor) {
            LogUtils.d("当前任务是请求广告");
            ThreadManager.getRequestAdPool().execute(netTask);
            return;
        }

        ThreadManager.getLongPool().execute(netTask);
    }
}
