package com.halomobi.network.request.ad;

import com.halomobi.network.listeners.AdRedirectChangListener;
import com.halomobi.network.listeners.AdStateChangListener;
import com.halomobi.network.request.ad.bean.AdParameter;

public class RequestAdManager {

    private static RequestAdManager mInstance;

    private RequestAdManager() {
    }

    public static synchronized RequestAdManager getInstance() {
        if (mInstance == null) {
            mInstance = new RequestAdManager();
        }
        return mInstance;
    }

    /**
     * 请求广告
     *
     * @param adParameter 广告数据对象
     * @param listener    回调Listener
     */
    public void requestAd(AdParameter adParameter, AdStateChangListener listener) {
        new RequestAdProcessor(adParameter, listener).process();
    }

    public void requestRedirectAd(String urlStr, AdRedirectChangListener listener) {
        new RequestRedirectAdProcessor(urlStr, listener).process();
    }
}
