package com.halomobi.network.request.ad;

import com.halomobi.network.net.AbsNetTask;
import com.halomobi.network.request.ad.bean.AdParameter;
import com.halomobi.network.request.ad.bean.AdRequest;
import com.halomobi.utils.HttpUrlSetting;

import java.net.HttpURLConnection;

/**
 * 广告加载任务
 *
 * @author Jeve
 * @since 2015-12-10
 */
class RequestAdTask extends AbsNetTask {

    private AdParameter parameter;

    RequestAdTask(AdParameter parameter) {
        super(ReqType.Post);
        this.parameter = parameter;
    }

    @Override
    public LaunchMode getLaunchMode() {
        return LaunchMode.REPLACE_OLD;
    }

    @Override
    public String getName() {
        return getClass().getSimpleName() + "  :  " + parameter.adSlotId;
    }

    @Override
    protected String getUrl() {
        return HttpUrlSetting.getRequestAdUrl();
    }

    @Override
    protected void onAddHeaders(HttpURLConnection connection) {
    }

    @Override
    protected byte[] getEntity() {
        try {
            return AdRequest.getParams(parameter);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return new byte[0];
    }
}
