package com.halomobi.network.request.ad;

import com.halomobi.network.net.AbsNetTask;
import com.halomobi.network.request.ad.bean.AdParameter;
import com.halomobi.network.request.ad.bean.AdRequest;
import com.halomobi.utils.HttpUrlSetting;

import java.net.HttpURLConnection;

/**
 * 广告加载任务
 *
 * @author Jeve
 * @since 2015-12-10
 */
class RequestRedirectAdTask extends AbsNetTask {
    private final String mUrlStr;

    RequestRedirectAdTask(String redirectUri) {
        super(ReqType.Get);
        mUrlStr = redirectUri;
    }

    @Override
    public LaunchMode getLaunchMode() {
        return LaunchMode.REPLACE_OLD;
    }

    @Override
    public String getName() {
        return getClass().getSimpleName();
    }

    @Override
    protected String getUrl() {
        return mUrlStr;
    }

    @Override
    protected void onAddHeaders(HttpURLConnection connection) {
    }

    @Override
    protected byte[] getEntity() {
        return null;
    }
}
