package com.halomobi.network.request.ad.bean;

import static com.halomobi.common.Config.AD_RENDER_TIME_OUT;
import static com.halomobi.common.Config.AD_REQUEST_TIME_OUT;
import static com.halomobi.common.ConstantPool.UA_KEY;

import android.util.SparseArray;

import com.halomobi.common.Config;
import com.halomobi.utils.SystemUtils;
import com.halomobi.utils.Utils;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.UUID;

public class Ad{
    public static final String SCREEN_ORIENTATION_PORTRAIT = "1";
    public static final String SCREEN_ORIENTATION_LANDSCAPE = "2";


    public String id;
    public String impid;
    public String[] imp_tracks;
    public String[] dp_tracks;
    public String[] click_tracks;
    public String[] down_start_tracks;
    public String[] down_complete_tracks;
    public String[] install_start_tracks;
    public String[] install_complete_tracks;
    public String title;
    public String des;
    public boolean showAdTitle;
    public boolean is_download;
    public boolean is_deep;
    public String landing_url;
    public String source;
    public double price;
    public String adid;
    public String bidid;
    public String nurl;
    public String burl;
    public String adm;
    public String crid;
    public String tagUriStr = "";//重定向uri
    public final String adUUID = UUID.randomUUID().toString();
    public String adSlotId;
    public int ad_type;
    public int opted; //1.点击关闭按钮可以关闭  2.点击关闭按钮不可以关闭
    public int w;
    public int h;
    public int show_w;//广告实际展示宽度
    public int show_h;//广告实际展示高度
    public int video_progress;
    public int video_progress_ms;
    public long response_time;
    public long ready_time;
    public long show_time;
    public long click_time;
    public int creative_type = 2;// 0：无创意类型，1：纯文字创意，2：纯图片创意，3:图文混合创意，4:H5创意。5:信息流广告
    public String bundle;// 下载类广告，Android应用包名，例：”com.wk.demo”
    public String imgurl;
    public String dplk = "";//deepLink链接
    public String clkurl = "";
    public int interaction_type = 1;// 0：无动作，1：使用浏览器打开网页，2：下载应用。此版本只支持使用浏览器打开网页
    public SparseArray<String[]> trackerGroup;
    public RewardVideoAds reward_video;
    public int lg;//logo来源。0：使用本地logo；1:使用返回资源
    public String lgsrc;//logo的url地址
    public long rqto = AD_REQUEST_TIME_OUT;//请求超时时间
    public long rdto = AD_RENDER_TIME_OUT;//渲染超时时间
    public long ctop = 1;//点击监播发送时机  1:开始加载落地页面时发送；2:落地页面加载完成时发送；3:点击就发送；4:开始下载时发送。
    public float down_x = 0;
    public float down_y = 0;
    public float up_x = 0;
    public float up_y = 0;
    public boolean isSubDisTrk;//为了避免重复发送监播，用来记录是否已经发送过
    public boolean isSubmitClkTrk;//为了避免重复发送监播，用来记录是否已经发送过
    public boolean isSubmitDeepLinkTrk;//为了避免重复发送监播，用来记录是否已经发送过
    public boolean isShow;//标记是否展示了
    public boolean isCached; //标记视频是否已经回调缓存成功监听.
    public boolean is25Report; // 激励视频播放进度25% 是否已经上报
    public boolean is50Report; // 激励视频播放进度50% 是否已经上报
    public boolean is75Report; // 激励视频播放进度75% 是否已经上报
    public String tencentClickId = "";//下载广告点击id


    public Set<String> getTracks(int type) {
        String mUserAgent = "";
        try {
            mUserAgent = URLEncoder.encode(Utils.getSp().getString(UA_KEY, ""), "utf-8");
        } catch (UnsupportedEncodingException e1) {
            e1.printStackTrace();
        }
        try {
            String[] tracks = trackerGroup.get(type);
            if (tracks == null || tracks.length == 0) {
                return new HashSet<>();
            }
            Set<String> trackSet = new HashSet<>();
            for (String track : tracks) {
                //点击监播上报点击位置
                trackSet.add(track.replace("${down_x}", (int)down_x + "").replace("${down_y}", (int)down_y + "")
                        .replace("${up_x}", (int)up_x + "").replace("${up_y}", (int)up_y + "").replace("${User-Agent}", mUserAgent)
                        .replace("__DOWN_X__", (int)down_x + "").replace("__DOWN_Y__", (int)down_y + "")
                        .replace("__UP_X__", (int)up_x + "").replace("__UP_Y__", (int)up_y + "").replace("__WIDTH__", show_w + "")
                        .replace("__HEIGHT__", show_h + "").replace("__CLICK_ID__", tencentClickId)
                        .replace("__PROGRESS__", video_progress + "").replace("__PROGRESS_MS__", video_progress_ms + "")
                        .replace("__READY_TIME__", ready_time + "").replace("__SHOW_TIME__", show_time + "")
                        .replace("__CLICK_TIME__", click_time + "").replace("__RESPONSE_TIME__", response_time + "")
                        .replace("__TS_S__", String.valueOf(System.currentTimeMillis()/100)).replace("__TS__", String.valueOf(System.currentTimeMillis()))
                        .replace("__PRICE__", String.valueOf(price)).replace("${AUCTION_PRICE}", String.valueOf(price)).replace("__BID_PRICE__", String.valueOf(SystemUtils.getInfoIntByJson("bidfloor")))
                );
            }
            return trackSet;
        } catch (Exception e) {
            e.printStackTrace();
            return new HashSet<>();
        }
    }


    public void setAdType(int ad_type) {
        this.ad_type = ad_type;
        setRqto(0);//根据ad_type设置默认广告请求超时时间
        setRdto(0);//根据ad_type设置默认广告渲染超时时间
    }

    public void setRqto(int value) {
        if (value == 0) {
            switch (ad_type) {//根据不同的广告类型，默认值不一样
                case 1://横幅
                case 2://开屏
                case 3://插屏
                case 4://原生
                case 5://激励视频
                case 6:
                    rqto = AD_REQUEST_TIME_OUT;
                    break;
                default:
                    rqto = AD_REQUEST_TIME_OUT;
                    break;
            }
        } else {
            rqto = value * 1000;
        }
    }

    public void setRdto(int value) {
        if (value == 0) {
            switch (ad_type) {
                //根据不同的广告类型，默认值不一样
                //横幅
                //开屏
                //插屏
                //原生
                default:
                    rdto = Config.AD_RENDER_TIME_OUT;
                    break;
            }
        } else {
            rdto = value * 1000;
        }
    }

    public void setCtop(int value) {
        if (value == 0) {
            switch (interaction_type) {//根据不同的点击类型，默认值不一样
                case 0://无动作
                case 1://使用内部webview加载
                    ctop = 2;
                    break;
                case 2://下载
                    ctop = 4;
                    break;
                case 3://使用系统Browser加载
                    ctop = 3;
                    break;
                default:
                    break;
            }
        } else {
            ctop = value;
        }
    }

    public static class RewardVideoAds{
        public String videoUrl;
        public String videoWidth;
        public String videoHeight;
        public String orientation;
        public String resolution;
        public String videoDuration;
        public String type;
        public boolean prefetch;
        public List<String> callbackUrl;
        //1.12.0 新增
        public String endCardType;
        public String endCardHtml;
        public String endCardUrl;
        public String endCardw;
        public String endCardh;
        public String title;
        public String subTitle;
        public String icon;
    }
}
