package com.halomobi.view.imageloader.cache;

public class DoubleCache implements ImageCache {

    private MemoryCache memoryCache = new MemoryCache();
    private DiskCache diskCache = new DiskCache();

    @Override
    public byte[] getCache(String url) {
        byte[] data = memoryCache.getCache(url);
        if (data == null) {
            data = diskCache.getCache(url);
            if (data != null) {
                memoryCache.putCache(url, data);
            }
        }
        return data;
    }

    @Override
    public void putCache(String url, byte[] data) {
        memoryCache.putCache(url, data);
        diskCache.putCache(url, data);
    }

    @Override
    public void clear() {
        memoryCache.clear();
        diskCache.clear();
    }

}
